package com.emoon.knowledge.service.impl;

import com.emoon.common.core.utils.MapstructUtils;
import com.emoon.common.core.utils.StringUtils;
import com.emoon.common.mybatis.core.page.TableDataInfo;
import com.emoon.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.emoon.knowledge.domain.QualityControlRuleExample;
import com.emoon.knowledge.domain.bo.QualityControlRuleExampleBo;
import com.emoon.knowledge.domain.vo.QualityControlRuleExampleVo;
import com.emoon.knowledge.mapper.QualityControlRuleExampleMapper;
import com.emoon.knowledge.service.IQualityControlRuleExampleService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.springframework.stereotype.Service;


import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 【请填写功能名称】Service业务层处理
 *
 * @author wangkang
 * @date 2025-11-25
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class QualityControlRuleExampleServiceImpl implements IQualityControlRuleExampleService {

    private final QualityControlRuleExampleMapper baseMapper;

    /**
     * 查询【请填写功能名称】
     *
     * @param id 主键
     * @return 【请填写功能名称】
     */
    @Override
    public QualityControlRuleExampleVo queryById(Long id){
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询【请填写功能名称】列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 【请填写功能名称】分页列表
     */
    @Override
    public TableDataInfo<QualityControlRuleExampleVo> queryPageList(QualityControlRuleExampleBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<QualityControlRuleExample> lqw = buildQueryWrapper(bo);
        Page<QualityControlRuleExampleVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的【请填写功能名称】列表
     *
     * @param bo 查询条件
     * @return 【请填写功能名称】列表
     */
    @Override
    public List<QualityControlRuleExampleVo> queryList(QualityControlRuleExampleBo bo) {
        LambdaQueryWrapper<QualityControlRuleExample> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<QualityControlRuleExample> buildQueryWrapper(QualityControlRuleExampleBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<QualityControlRuleExample> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(QualityControlRuleExample::getId);
        lqw.eq(StringUtils.isNotBlank(bo.getRuleCode()), QualityControlRuleExample::getRuleCode, bo.getRuleCode());
        lqw.eq(StringUtils.isNotBlank(bo.getType()), QualityControlRuleExample::getType, bo.getType());
        lqw.eq(StringUtils.isNotBlank(bo.getExampleContent()), QualityControlRuleExample::getExampleContent, bo.getExampleContent());
        lqw.eq(StringUtils.isNotBlank(bo.getExampleDesc()), QualityControlRuleExample::getExampleDesc, bo.getExampleDesc());
        lqw.eq(StringUtils.isNotBlank(bo.getStatus()), QualityControlRuleExample::getStatus, bo.getStatus());
        lqw.eq(StringUtils.isNotBlank(bo.getDefFlag()), QualityControlRuleExample::getDefFlag, bo.getDefFlag());
        return lqw;
    }

    /**
     * 新增【请填写功能名称】
     *
     * @param bo 【请填写功能名称】
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(QualityControlRuleExampleBo bo) {
        QualityControlRuleExample add = MapstructUtils.convert(bo, QualityControlRuleExample.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改【请填写功能名称】
     *
     * @param bo 【请填写功能名称】
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(QualityControlRuleExampleBo bo) {
        QualityControlRuleExample update = MapstructUtils.convert(bo, QualityControlRuleExample.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(QualityControlRuleExample entity){
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除【请填写功能名称】信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
